#include "plugin.hpp"

//---------    ---------------

class Link {
  Link *prev;
  Link *next;
  public:
  Link(){prev=next=NULL;};
  Link *Prev(void){return prev;};
  Link *Next(void){return next;};
  Link *Head(void);         //   
  Link *Tail(void);         //   
  Link *Find(int num);     //     num (    0)
  void After(Link *m);      //    m  this
  void Before(Link *m);     //    m  this
  Link *Add(Link *m);       //    m   .  m.
                            // this     .   NULL.
  void Extract(void);       //   this   
  Link *DestroyAll(void);   //   .  NULL.
  Link *Step(char &dir);    //    dir.
  Link *Destroy(char &dir); //     .
/*        ( dir='N'  next,   prev).
       NULL (   
  ),  dir     .
        ,        
     .    NULL,   , 
     ).
*/
  };

//==================   ==================
BYTE Upper(BYTE c);
char *Upper(char *text);
__int64 a_i64(char *s, __int64 def, char dec=0);
   // Dec- c   . dec   .
   //    def
   // : a_i64("12.35",0,3) --> 12350

char *i64_a(char *s, __int64 val, char mins=1, char dec=0);
   //   Dec-.   mins  .
   // mins>=0 -   , mins<0 -  .
   // dec   .  s.

__int64 ah_i64(char *s, __int64 def);
   // Hex-  .    def

//==================      ==================

// :
//  __int32 -     
//  Digit (char*) - dd.mm.yy
//  Text  (char*) - 12  1993 .
/*
struct Monthes {
  BYTE days;
  char name[10];
  };

extern Monthes Mon[];  //  
*/
extern BYTE Mon[];  //  
extern char DatePoint; //    Digit = '/'

BYTE BadDate(BYTE d,BYTE m,WORD y); // 1 - bad; 0 - good
BYTE UnpackDate(__int32 d, BYTE &day, BYTE &month, WORD &year); //1-bad; 0-good
__int32 Date4(char *d);
char *DateDigit(__int32 d, char *buf);

//==================  ==================

bool NotNum(char c);
BYTE MyWrite(HANDLE h, BYTE *buf, DWORD len=0);

//---------      DBF ---------------
union dbVal {
  __int64 I;
  double  D;
  };

struct dbHeader {
  BYTE  type;
  BYTE  upd[3];
  DWORD nrec;
  WORD  start;
  WORD  reclen;
  WORD  spare1[8];
  BYTE  ind;
  BYTE  spare2[3];
  };

struct dbField:Link {
  char  name[11];
  BYTE  type;
  DWORD loc;
  BYTE  filen;
  BYTE  dec;
  BYTE  spare[14];
  };

struct dbBase {
  HANDLE f,m;
//  FILE     *f,*m;
  dbHeader  dbH;
  dbField  *dbF;
  dbField  *cf;   //       dbF
  DWORD    pos;   //       .  
  DWORD    cur;   //      1. 0 -   
  BYTE     *rec;  //  
  WORD     fpos;  //     rec
  WORD     nfil;  //    
  WORD     tmem;  //  Memo- 0-dBaseIII, 1-dBaseIV, 2-FoxPro
  WORD     lmem;  //    Memo-
  WORD     upd;

  dbBase()  { ZeroMemory(this,sizeof(dbBase)); f=m=INVALID_HANDLE_VALUE; }
  ~dbBase() { Close(); }

  BYTE Invalid(void) { return (rec[0]=='*'); };
        //  1,     .  0.
  void Add(char *fname, char ftype, BYTE flen, BYTE fdec);
       //      dbF
  BYTE Open(char *file, BYTE ronly=0);
       //       
       // 0 - OK, 1 - 
  void OpenMemo(char *file);
       //   ,        
  BYTE Create(char *file, BYTE t);
       //   ,     dbBase
       // 0 - OK, 1 - 
  void SaveHeader(void);
       //  
  void Close(void);
       //  

  BYTE NextRec(void);
       //   .  pos  cur.
       // : 0 - OK, 1 -    ,
       //          2 -   .
  BYTE CurrRec(void);
       //   .  pos  cur.
       // : 0 - OK, 1 -     (cur=0),
       //          2 -   .
  BYTE PrevRec(void);
       //   .  pos  cur.
       // : 0 - OK, 1 -    ,
       //          2 -   .
  BYTE Read(DWORD rn);
       //     rn (  1).
       //  pos  cur.   .
       // : 0 - OK, 1 - rn   ,
       //          2 -   .
  BYTE Write(void);
       //  rec    pos.
       //  pos  cur.   .
       // : 0 - OK, 2 -   .
  BYTE ReWrite(void);
       //  rec   .
       // pos  cur  .
       // : 0 - OK, 1 -     (cur=0),
       //          2 -   .
  BYTE Append(void);
       //  rec      .
       //  pos  cur,  dbH.nrec.   .
       // : 0 - OK, 2 -   .

  dbField *FiName(char *fname);
       //    dbF    fname.
       //  cf  fpos,  cf.
       //   ,  cf=NULL, fpos=0.
  dbField *FiNum(WORD fnum);
       //    dbF    fnum (  0).
       //  cf  fpos,  cf.
       //   ,  cf=NULL, fpos=0.
  WORD FiDisp(char* s);
       //         
       //       s.    .
       //   .
  WORD FiDispE(char* s);
       //  ,    .   .
  char *FiType(void);
       //         1 
  WORD FiWidth(void);
       //       

  void Clear(void);
       //   rec
  void SetEmpty(void);
       //        rec.
  BYTE IsEmpty(void);
       //      
  BYTE SetFiEmpty(char *fname);
       //         fname.
       //  ,  0.      1.
  void SetLeft(char *fval);
       //  fval     rec.  .
  BYTE SetFiLeft(char *fname, char *fval);
       //         fname.
       //  ,  0.      1.
  void SetRight(char *fval);
       //  fval     rec.  .
  BYTE SetFiRight(char *fname, char *fval);
       //         fname.
       //  ,  0.      1.
  void SetLong(long fval, char dec=1);
       //    I (Integer*4),    . ,
       //  fval  ,      
       //       rec.  .
       //  ,  dec=1.   dec=0  .
       // :
       //  Number 8.2 SetLong(12345[,1]) -->   123.45
       //  Number 8.2 SetLong(12345,0)   --> 12345.00
       //  Number 8.0 SetLong(12345[,1]) -->    12345
       //  Number 8.0 SetLong(12345,0)   -->    12345
       //  Number 6.2 SetLong(12345[,1]) -->   123.45
       //  Number 6.2 SetLong(12345,0)   -->   ***.**
  BYTE SetFiLong(char *fname, long fval, char dec=1);
       //         fname.
       //  ,  0.      1.
  void SetDouble(double fval);
       //  fval          rec.
       //  .    .
  BYTE SetFiDouble(char *fname, double fval);
       //         fname.
       //  ,  0.      1.
  void SetField(char *s);
       //      ,   
       //    .

  void Accum(dbVal *V);
  BYTE Numeric(void);
  BYTE *GetByte(BYTE *s);
  void SetByte(BYTE *fval);
  BYTE GetMemo(char *file, DWORD *blocknum=NULL);
  char *GetRight(void);
       //        .
       //     .
       //     delete.
       //  NULL,    .
  char *GetRight(char *s);
       //      s.
       //     .
       //  NULL,    .
  char *GetRight(char *s, WORD n);
       //     n   s.
       //     .
       //  NULL,    .
  char *GetLeft(char *s);
       //      s,   ( 
       //   ).
       //     .
       //  NULL,    .
  __int64 Get64(void);
  __int64 GetBinary(void);
  long GetLong(void);
       //           .
       //     .   T (DateTime),  0.
       //   I (Integer*4),    .
       //   L (Logical),   0(false)  1(true).
       //          , 
       //       dec  :
       //  Number 6.2  123.45 --> GetLong()=12345
       //  Number 6.2  1234.5 --> GetLong()=123450
  char *GetDate(char *s);
       //       D (Date)   DateDigit
       //    s     
  WORD GetDate(void);
       //      .
       //       (. ).
       //  ,    .
  void GetDT(WORD *d, WORD *t);
       //     8- DateTime binary ( T).
       //   d   t     (. ).
       //  ,    .
  double GetDouble(void);
       //       double    .
  };
